using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace Interval.TemplateColumns
{
	/// <summary>
	/// Tda reprezentujc ablonu sloupce s obrzkem
	/// </summary>
	internal class ImageTemplate : ITemplate
	{
		
		#region private variables
		private string m_dataField;
		#endregion private variables
		
		/// <summary>
		/// Konstruktor
		/// </summary>
		public ImageTemplate() : base()
		{
		}

		
		#region ITemplate implementation
		/// <summary>
		/// Explicitn implementace metody <see cref="ITemplate.InstantiateIn"/>
		/// </summary>                                                                                                                                                                                                                                                                                                                                                   
		void ITemplate.InstantiateIn(Control container)
		{
			Image image = new Image();
			image.DataBinding += new EventHandler(setImageSrc);
			container.Controls.Add(image);
		}
		#endregion ITemplate implementation

		
		#region Puvlic properties
		/// <summary>
		/// Sloupec v datovm zdroji, ve kterm je uloena cesta k
		/// </summary>
		public string DataField
		{
			get
			{
				return m_dataField;
			}
			set
			{
				m_dataField = value;
			}
		}

		#endregion Public properties
		#region Private methods
		/// <summary>
		/// Zskn URL obrzku z datovho zdroje a piazen URL do vlastnosti <see cref="Image.ImageUrl"/>
		/// </summary>
		private void setImageSrc(object sender, EventArgs e)
		{
			Image image = (Image) sender;
			image.ImageUrl = String.Empty;
			
			DataGridItem item = (DataGridItem) image.NamingContainer;
			
			if (item.DataItem is DataRowView)
				image.ImageUrl = ((DataRowView)item.DataItem)[this.DataField].ToString();
			
			else if (item.DataItem is IDataRecord)
			{
				IDataRecord record = (IDataRecord)item.DataItem;
				image.ImageUrl = record.GetString(record.GetOrdinal(this.DataField));
			}
		}
		#endregion Private methods
	}
}
